import tangram.BigNumber
import tangram.Log
import tangram.SQLcmd

// zoznam tovarov s aktualnou cenou (GET), query-parametre:
// [store=XXX] kod predajne (povinny)
// [minutes=nn] len zmenene zaznamy za poslednych n minut (ak sa neuvedie, bezi full-export)
urlPriceList (sql, request, json)

private static void urlPriceList (tangram.SQLconn sql, tangram.http.TangramHttpRequest request, tangram.TangramJsonWriter json)
{
    // Parametre z URL a konfiguracie (Tangram.ini)
    String store = request.queryMap.getString('store').toUpperCase()
    int minutes = request.queryMap.getInt('minutes')
    String censkup = "MC1"		// cfg.str('EshopPriceGroup', 'MOC')
    String censkup2 = "COOP"	// cfg.str('EshopPriceGroup2', 'COOP')
    String sku = request.queryMap.getString('sku')

	//ak je zadany filter na zaznamy zmenene za zadane obdobie, je hodnoteny aj parameter x_eslexp ktory ak obsahuje hodnotu A je akceptovany do filtra
	//sluzi na nutenu synchronizaciu konkretneho tovaru pripadne celeho ciselniku
    String tovfilter = ''
    if (minutes) tovfilter = """
        and (exists (select null FROM TOVARY X WHERE X.Xx=T.Xx and nvl(X.Xud,X.Xid) > (sysdate - interval '$minutes' minute))
           or exists (select null FROM TOVCENY X WHERE X.Kod=T.Xx and nvl(X.Xud,X.Xid) > (sysdate - interval '$minutes' minute))
		   or t.x_eslexp is not null)
    """
   
    if (sku) tovfilter = """ and T.xx='$sku'"""

    // zistenie typu retazca
//    def retazec= ""
//    def row = sql.queryRows("SELECT typ from adresa where xx='$store'")
//    while (row.next()) retazec=row.typ
//    row.close()
	String retazec = sql.queryValueStr("SELECT typ from adresa where xx='$store'")

    // Nacitanie riadkov z tabulky TOVARY
    GString select = """
    SELECT T.*, 
		C.Cm_sdph "price", C.Akcia "akcia", C.zl_typ as zl_typ, C.typceny as typceny,
		B.Cm_sdph "priceBasic", B.KodAkcia "akcia2", B.zl_typ as zl_typ_b, B.typceny as typceny_b, 
		C2.Cm_sdph "price2", 
		F.Nazov1 "vyrobca_nazov", povod.nazov "povod_nazov", RP.Cm_sdph as rp_price
    FROM TOVARY T 
	LEFT JOIN
	( SELECT Kod,
		max(Cm_sdph) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as Cm_sdph,
		max(Akcia) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as Akcia,
		max(zl_typ) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as zl_typ,
		max(typceny) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as typceny
	  FROM TOVCENY
      WHERE Censkup='$censkup' and (trunc(sysdate) between Datum_od and Datum_do) and (Typceny='B' or (Typceny='D' and Adresa='$store') or (Typceny='C' and Adrtyp='$retazec'))
	  GROUP BY Kod
    ) C ON (C.Kod=T.Xx)
	LEFT JOIN
	( SELECT Kod, min(Cm_sdph) as Cm_sdph,  
		 max(Akcia) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as KodAkcia,
		 max(zl_typ) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as zl_typ,
		 max(typceny) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as typceny
	  FROM TOVCENY
	  WHERE Censkup='$censkup' and (trunc(sysdate) between Datum_od and Datum_do) and Typceny='A'
	  GROUP BY Kod
	) B ON (B.Kod=T.Xx)
	LEFT JOIN
	( SELECT Kod, min(Cm_sdph) as Cm_sdph,  
		 max(Akcia) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as KodAkcia,
		 max(zl_typ) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as zl_typ,
		 max(typceny) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as typceny
	  FROM TOVCENY
	  WHERE Censkup='$censkup' and (trunc(sysdate) between Datum_od and Datum_do) and (Typceny='A' or Typceny='B' or (Typceny='D' and Adresa='$store') or (Typceny='C' and Adrtyp='$retazec'))
	  GROUP BY Kod
	) RP	ON (RP.Kod=T.obal)
	LEFT JOIN
	( SELECT Kod, min(Cm_sdph) as Cm_sdph FROM TOVCENY
	  WHERE Censkup='$censkup2' and (trunc(sysdate) between Datum_od and Datum_do) 
	  GROUP BY Kod
	) C2 ON (C2.Kod=T.Xx)
	LEFT JOIN (SELECT xx,nazov1,Mesto,Ulica FROM FIRMY) F ON (F.Xx=T.Vyrobca)
	-- LEFT JOIN (SELECT Kod,xn FROM vahyr group by kod,xn) S ON (T.Xx=S.Kod)
	LEFT JOIN (SELECT xx,nazov FROM c_staty) povod ON (T.povod=povod.xx)
	WHERE t.neaktivna is null and t.xx not like '{%}' and t.xx not like 'MTZ%'
	$tovfilter
    ORDER BY T.Xx
    """
	
	Log.debug (select)

	SQLcmd rows = sql.queryRows(select)

    // Response header
    request.sendHeaderJSON()

    // Reponse body
    json.begin()
    json.arrayBegin('items')
    while (rows.next())
    {
        // dopocitane hodnoty
        String kod = rows.getString("xx")
        BigNumber basic = rows.getBigNumber("priceBasic")
        BigNumber price = rows.getBigNumber("price")
        BigNumber price2 = rows.getBigNumber("price2")
        Log.debug("kod=$kod, basic=$basic, price=$price")
        BigNumber discount = new BigNumber()
        String expire = (! rows.scale_plu) ? null : '24'
		if (price.nullOrZero) price = basic
        else discount = ((basic - price) / basic * (new BigNumber(100))).round(1)

        BigNumber jkoef = rows.getBigNumber("jkoef")
        BigNumber unitPrice = jkoef.nullOrZero ? new BigNumber() : (price / jkoef).round(3)
        BigNumber unitPrice2 = jkoef.nullOrZero ? new BigNumber() : (price2 / jkoef).round(3)

        // vyber typu template
		String typceny = rows.getString("typceny")
		if (typceny == '') typceny = rows.getString("typceny_b")
		String kodAkcia = rows.getString("akcia")
	
		//ak je bezna cena nizsia ako akciova, je pouzita nizsia cena
		if (basic.isNonZero() && basic.compareTo(price)<0) { price = basic; kodAkcia=rows.getString("akcia2"); typceny = 'A'; discount=new BigNumber(0) }

        //zvolenie template ESL podla typu oznacenia akcie
		if (! kodAkcia) kodAkcia = rows.getString("akcia2")
		String template = calcTemplate(price2, kodAkcia, typceny, rows.getString("nazov"))

        // zapis do JSON (jeden tovar) len ak je nenulova cena
		if (price != null && price.nonZero)
		{
			json.blockBegin()
			json.pair("sku", kod)
			json.pair("store", store)
			json.pair("retazec", retazec)
			json.pair("sku_pack", rows.obal)
			json.pair("rp_price", rows.rp_price)
			json.pair("name", rows.nazov)
			json.pair("short_name", rows.nazovplu)
			json.pair("unit_price", unitPrice)
			json.pair("unit_price2", unitPrice2)
			json.pair("unit", rows.jmj)
			// json.pair("place_of_origin", rows.povod)
			// json.pair("place_of_origin_name", rows.povod_nazov)
			json.pair("price", price)
			json.pair("price2", price2)
			json.pair("price_old", basic)
			json.pair("discount_value", discount)
			json.pair("spec", rows.zlozenie)
			json.pair("template", template)
			json.pair("kod_akcia", kodAkcia)
			json.pair("category", rows.druh)
			json.pair("allergens", rows.fo_alergeny)
			json.pair("product_type", rows.x_druhvyr)
			json.pair("manufacturer", rows.vyrobca_nazov)
			// json.pair("scale_plu", rows.scale_plu)
			json.pair("expire", expire)
			json.pair("dni", rows.zardni)
			json.pair("poznamka", rows.pozn)

			// pole ciarovych kodov
			exportBarcodes(sql, json, kod)

			// zoznam precenenia
			String zl_typ = rows.getString("zl_typ") ?: rows.getString("zl_typ_b")
			// def zl_typ_b = rows.getString("zl_typ_b")
			// if (zl_typ=='') zl_typ = zl_typ_b
			if (zl_typ!='A') exportPaging(json, price, unitPrice)

			// koniec bloku (jeden tovar)
			json.blockEnd()
		}
    }
    json.arrayEnd()
    json.end()

    rows.close()

	// vymazeme priznak "exportovat cenovky" v databaze (X-parameter)
	sql.execute("update tovary set x_eslexp=null where x_eslexp is not null")
}

// ---------- POMOCNE FUNKCIE -------------
private static String calcTemplate (BigNumber price2, String kodAkcia, String typceny, String nazov)
{
	if (price2.nonZero) return "6"
	if (nazov!=null && nazov.contains("COOP")) return "4"	// Vlastna znacka
	if (kodAkcia == null && typceny == 'A') return "1"
	if (kodAkcia == null  && typceny != 'A') return "2"
	if (kodAkcia == "DNC") return "3"
	// if (kodAkcia == "VZ") return "4"
	if (kodAkcia == "P") return "1"
	if (kodAkcia == "VA") return "2"
	if (kodAkcia.startsWith("TA")) return "2"	//akcia TA zavedene 09.04.2024 oznacenie v zmysle TAytt TA- tyzdnova akcia, y-posledne cislo roku, tt-cislo tyzdna zaciatku akcie
	if (kodAkcia.indexOf("A") > 0) return "2"
	if (kodAkcia.indexOf("B") > 0) return "2"
	if (kodAkcia.indexOf("C") > 0) return "2"
	if (kodAkcia.indexOf("D") > 0) return "2"
	if (kodAkcia.indexOf("G") > 0) return "2"
	if (kodAkcia.indexOf("U") > 0) return "2"
	if (kodAkcia.indexOf("I") > 0) return "3"
	if (kodAkcia.indexOf("M") > 0) return "2"
	if (kodAkcia.indexOf("N") > 0) return "2"
	if (kodAkcia.indexOf("L") > 0) return "2"
	if (kodAkcia.indexOf("P") > 0) return "3"
	if (kodAkcia.indexOf("E") > 0) return "2"
	if (kodAkcia.indexOf("F") > 0) return "2"
	if (kodAkcia.indexOf("T") > 0) return "3"
	if (kodAkcia.indexOf("V") > 0) return "3"
	if (kodAkcia.indexOf("X") > 0) return "2"
	if (kodAkcia.indexOf("Y") > 0) return "2"
	return "1"
}

// export ciarovych kodov
private static void exportBarcodes (tangram.SQLconn sql, tangram.TangramJsonWriter json, String kod)
{
    // zoznam ciarovych kodov do Listu
    def barcodes = []
    SQLcmd rows = sql.queryRows("SELECT Barcode FROM TOVBARCODE WHERE Kod='$kod' ORDER BY Hlavny")
    while (rows.next()) barcodes.add(rows.getString("barcode"))
    rows.close()

    // export pola do JSON
    json.array(barcodes, "ean")
}

// export bloku "paging"
private static void exportPaging (tangram.TangramJsonWriter json, tangram.BigNumber price, tangram.BigNumber unitPrice)
{
	json.blockBegin('paging')
		//json.blockBegin('3')
			//json.pair("unit_price", (unitPrice*(new BigNumber(0.8))).round(3))
			//json.pair("price", (price*(new BigNumber(0.8))).round(2))
			//json.pair("discount_value", "20")
		//json.blockEnd()
		json.blockBegin('4')
			json.pair("unit_price", (unitPrice*(new BigNumber(0.7))).round(3))
			json.pair("price", (price*(new BigNumber(0.7))).round(2))
			json.pair("discount_value", "30")
		json.blockEnd()
		json.blockBegin('5')
			json.pair("unit_price", (unitPrice*(new BigNumber(0.5))).round(3))
			json.pair("price", (price*(new BigNumber(0.5))).round(2))
			json.pair("discount_value", "50")
		json.blockEnd()
		//json.blockBegin('6')
			//json.pair("unit_price", (unitPrice*(new BigNumber(0.2))).round(3))
			//json.pair("price", (price*(new BigNumber(0.2))).round(2))
			//json.pair("discount_value", "80")
		//json.blockEnd()
	json.blockEnd()
}